;Wait routines of 1 sec and 1 ms
;
; prototypes
;   void wait1ms(void);   waits one millisecond
; OLD  void wait(int msec);  waits for msec milliseconds OLD
;   void wait(unsigned short int msec);  waits for msec milliseconds
;
;
;Written by Steven L. Barnicki, Ph.D. (for GCC 2.8.1)
;       2/7/98, v1.0
;
	.globl wait
	.globl wait1ms

wait:
    ; EAD: GCC 3.0.4: according to the documentation, we're allowed to clobber D, X, and Y
    ; Experimentation shows that the msec argument comes in via D.
    ; ASSUMPTION: we can modify the CCR (otherwise use TPA trick...)

    xgdx    ; existing code wants count in IX, but we receive it in D
	; OLD: ldx *ZD0      ;wait ZD0 milliseconds -- 2.8.1 soft register

.L1:     jsr wait1ms
	dex
	bne .L1

	rts

wait1ms:
	psha    ;1 ms wait
	tpa
	psha
	pshx
	ldx #200
.L2:     dex
	nop
	nop
	bne .L2
	pulx
	pula
	tap
	pula
	rts
